#include "config.h"
#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_WINDOWS_H
#include <windows.h>
#define FD_SETSIZE 1024
#include <winsock.h>
#define getpid()	_getpid()
#define __ANSI_CPP__
#else
#include <unistd.h>
#ifdef HAVE_SYS_TIME_H
#include <sys/time.h>
#endif
#ifdef HAVE_SYS_TIMES_H
#include <sys/times.h>
#endif
#include <sys/socket.h>
#ifdef HAVE_SYS_SELECT_H
#include <sys/select.h>
#endif
#ifdef HAVE_SYS_UIO_H
#include <sys/uio.h>
#endif
#ifdef HAVE_SYS_UN_H
#include <sys/un.h>
#endif
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#ifdef HAVE_NETDB_H
#include <netdb.h>
#endif
#include <signal.h>
#endif
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>
#ifdef HAVE_MEMORY_H
#include <memory.h>
#endif

#include "io.h"
#include "io_interface.h"
#include "io_internal.h"
#include "unix_defs.h"
#ifdef HAVE_MALLOC_H
#include <malloc.h>
#endif
#include <string.h>
#include <assert.h>
typedef struct format_list {
    IOFormat	format;
    time_t	last_reference;
    struct format_list *next;
} format_list;
int
main()
{
    int fd = open("/tmp/FS_restart_file", O_RDONLY, 0600);
    format_rep rep;

    while (1) {
	IOFormat ioformat;
	format_list *new;
	UINT2 id_len, rep_len;
	char id[128];  /* too big */
	if (serverAtomicRead((void*)fd, &id_len, sizeof(id_len)) != sizeof(id_len)) {
	    close(fd);
	    return 0;
	}
	if (serverAtomicRead((void*)fd, &id[0], id_len) != id_len) {
	    close(fd);
	    return 0;
	}
	if (serverAtomicRead((void*)fd, &rep_len, sizeof(rep_len))!=sizeof(rep_len)) {
	    close(fd);
	    return 0;
	}
	printf("rep_len is %d\n", rep_len);
	rep = io_malloc(rep_len);
	rep->format_rep_length = rep_len;
	if (serverAtomicRead((void*)fd, ((char*)rep) + sizeof(rep_len), 
			     rep_len - sizeof(rep_len)) !=
	    (rep_len - sizeof(rep_len))) {
	    close(fd);
	    return 0;
	}
	ioformat = expand_ioformat_from_rep(rep);
	ioformat->body->server_ID.length = id_len;
	ioformat->body->server_ID.value = malloc(id_len);
	memcpy(ioformat->body->server_ID.value, id, id_len);
	printf("byte reversal = %d\n", 	ioformat->body->byte_reversal);
	print_server_ID((unsigned char *)id);
	dump_IOFormat(ioformat);
	new = (format_list*) io_malloc(sizeof(format_list));
	new->format = ioformat;
	new->next = NULL;
    }
}

