
#include <stdio.h>
#include "config.h"
#include "sensor.h"

/*** check sensor name validity (against duplicate name) ***/
int ValidSensor(sensor_p, rest)
SensorP  sensor_p, rest;
{
    AttributeP  attr;
    while (rest) {
	if (!strcmp(sensor_p->name, rest->name)) {
	    fprintf(stderr, "Error: sensor %s redefined\n", sensor_p->name);
	    return False;
	} else rest = rest->next;
    }
    attr = sensor_p->attributes;
    while (attr) {
	if (attr->arraySize > 1) {sensor_p->have_array_fld = True;return True;}
	attr = attr->next;
    }
    attr = sensor_p->samp_attrs;
    while (attr) {
	if (attr->arraySize > 1) {sensor_p->have_array_fld = True;return True;}
	attr = attr->next;
    }
    return True;
}



/*** check attribute name validity (against duplicate name) ***/
int ValidAttribute(attribute, rest)
AttributeP  attribute, rest;
{
    while (rest) {
	if (!strcmp(attribute->name, rest->name)) {
	    fprintf(stderr, "Error: attribute %s redefined\n", attribute->name);
	    return False;
	} else rest = rest->next;
    }
    return True;
}

